<template>
  <SinglePane>
    <div
      class="group-heading"
      @click="goBack"
    >
      <span class="icon chevron-left" /> Группа «{{ groupData.title || '—' }}»
    </div>

    <ObTable
      :columns="columns"
      :functionalPanel="true"
      :with-checkboxes="true"
      :checked-rows="selectedRows"
      :is-functional-group="false"
      :is-functional-sort="false"
      :is-functional-filter="!selectedRows.length"
      :show-add-button="!selectedRows.length"
      add-button-text="Добавить контрагента"
      @select="onSelection"
      @add="onAdd"
      @row-toggle="onToggle"
      ref="participantsTable"
      :remote-opt="{
        method: fetchTableData,
        contentKey: 'participants'
      }"
      data-qa="tendersGroupsForm"
    >

<!--      :is-functional-group="!selectedRows.length"-->
<!--      :is-functional-sort="!selectedRows.length"-->

      <template slot="extraFuncButtons">
        <div
          v-if="selectedRows.length"
          class="selected-rows-info"
        >
          <div class="selected-rows-info__title">
            Выбрано: {{ plural(selectedRows.length, ['запись', 'записи', 'записей']) }}
          </div>

          <div
            class="selected-rows-info__button"
            data-qa="deleteSelectedRows"
            @click="onDeleteSelectedRows"
          >
            <i class="icon delete" /> Удалить
          </div>
        </div>
      </template>

      <template slot="noneContent">
        <div class="title">
          Здесь еще нет ни одной записи.<br>
          Добавляйте контрагентов и управляйте их списком
        </div>

        <ObButton
          label="Добавить контрагента"
          type="flat"
          data-qa="btnAdd"
          @click="onAdd"
        />
      </template>
    </ObTable>

    <ObModal
      ref="viewItem"
      :title="this.selectedData.name"
      custom-class="modal-md"
      :is-show-pagination="false"
      :is-show-controls="true"
      :dropdown-menu="dropdownMenu"
      :is-read-only="true"
      data-qa="tendersGroupsViewItemModal"
    >
      <TendersParticipantCard
        :data="selectedData"
        :key="selectedData.uuid"
      />
    </ObModal>

    <ObModal
      ref="confirmDeleteRows"
      title="Удаление контрагентов"
      size="sm"
      :is-show-pagination="false"
      :is-show-controls="true"
      ok-text="Удалить"
      cancel-text="Отменить"
      data-qa="confirmDeleteRowsModal"
      @submit="deleteSelectedRows"
    >
      Вы точно хотите удалить {{ this.selectedRows.length }} контрагентов?
    </ObModal>

    <ObModal
      ref="addToGroupModal"
      :title="`Добавление контрагентов в группу «${this.groupData.title}»`"
      size="max"
      :is-show-pagination="false"
      :is-show-controls="true"
      :is-submit-disabled="disableAppend"
      ok-text="Добавить"
      data-qa="addToGroupModal"
      @submit="onAddToGroup"
    >
      <TendersAddToGroup
        ref="addToGroup"
        @change="onAddGroupChanged"
      />
    </ObModal>
  </SinglePane>
</template>

<script>
  import itemMixin from '@/mixins/dictionaries/edit-item'
  import paging from '@/mixins/dictionaries/paging'
  import SinglePane from 'common-components/src/obComponents/obSinglePanels'
  import ObModal from 'common-components/src/obComponents/obModal'
  import ObTable from 'common-components/src/obComponents/obTable'
  import ObButton from 'common-components/src/obComponents/obButton'
  import TendersParticipantCard from './modal/participantCard'
  import TendersAddToGroup from './modal/addToGroup'
  import api from '@/api'
  import { plural } from '@/helpers'

  export default {
    name: 'TendersGroup',
    components: {
      TendersAddToGroup,
      TendersParticipantCard,
      ObModal,
      SinglePane,
      ObTable,
      ObButton
    },
    mixins: [
      paging,
      itemMixin
    ],
    computed: {
      columns () {
        return [
          {
            title: 'Название контрагента',
            key: 'shortTitle'
          },
          {
            title: 'ИНН',
            key: 'inn'
          },
          {
            title: 'Юридический адрес',
            key: 'legalAddress'
          },
          {
            title: 'Описание',
            key: 'description',
            html: ({ description }) => { return this.getDescription(description) }
          },
          {
            title: 'Телефон',
            key: 'phone'
          },
          {
            title: 'Эл. почта',
            key: 'email'
          }
        ]
      },
      dropdownMenu () {
        return [
          {
            title: 'Удалить из этой группы',
            method: () => this.deleteFromGroup()
          }
        ]
      },
      disableAppend () {
        return this.rowsToAppend.length === 0
      }
    },
    data () {
      return {
        api,
        groupData: [],
        tableData: {},
        selectedData: {},
        rowsToAppend: [],
        selectedRows: []
      }
    },
    async mounted () {
      this.groupData = await api.tendersContractors.getParticipantGroup(this.$route.params.uuid)
    },
    methods: {
      plural,
      async fetchTableData (params) {
        try {
          const { data, status } = await api.tendersContractors.getParticipantsOfParticipantsGroup(this.$route.params.uuid, params)

          if (status === 404) {
            this.$notification({
              type: 'system_notification_error',
              message: 'Группа не найдена'
            })
            this.$router.push('/tenders-contractor-groups')
          }

          return this.tableData = data
        }
        catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
        }
      },
      goBack () {
        this.$router.push({
          path: `/tenders-contractor-groups/`
        })
      },
      onSelection (data) {
        this.selectedData = data

        this.$refs.viewItem.open()
      },
      async deleteFromGroup () {
        await api.tendersContractors.deleteParticipantsFromGroup(this.$route.params.uuid, {
          participants: [ this.selectedData.uuid ]
        })

        await this.updateTables()
        this.$refs.viewItem.close()
      },
      async deleteSelectedRows () {
        await api.tendersContractors.deleteParticipantsFromGroup(this.$route.params.uuid, {
          participants: this.selectedRows
        })

        await this.updateTables()
        this.selectedRows = []
        this.$refs.confirmDeleteRows.close()
      },
      async updateTables () {
        await this.$refs.participantsTable.loadData({ init: true })

        if (this.$refs.addToGroup) {
          this.$refs.addToGroup.reloadData()
        }
      },
      onAdd () {
        this.$refs.addToGroupModal.open()
      },
      async onAddToGroup () {
        await api.tendersContractors.addParticipantsToGroup(this.$route.params.uuid, {
          participants: this.rowsToAppend
        })

        this.rowsToAppend = []

        await this.$refs.participantsTable.loadData({ init: true })
        this.$refs.addToGroup.reloadData()
        this.$refs.addToGroupModal.close()
      },
      onToggle (item, selectedUuids) {
        this.selectedRows = selectedUuids
      },
      onAddGroupChanged (selectedUuids) {
        this.rowsToAppend = selectedUuids
      },
      onDeleteSelectedRows () {
        this.$refs.confirmDeleteRows.open()
      },
      getDescription (description) {
        return description || '—'
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import '~common-components/src/static/css/mixins';
  .group-heading {
    @include font-mixin(24px, 36px, 700, $color-text-base, 0.2px);

    padding: 20px;
    z-index: 1;
    display: flex;
    align-items: center;
    box-shadow:
      0 0 2px rgba($blue-700, .15),
      0 0 12px rgba($blue-700, .04),
      0 4px 10px rgba($blue-700, .06);

    .icon {
      font-size: 24px;
      margin-right: 10px;
      cursor: pointer;
      color: $color-blue-navy-blue;
    }
  }

  .selected-rows-info {
    @include font-mixin(16px, 20px, 400, $color-text-base);

    display: flex;
    align-items: center;

    &__title {
      margin-right: 20px;
    }

    &__button {
      color: $color-error;
      cursor: pointer;
      display: flex;
      align-items: center;

      .icon {
        font-size: 24px;
        display: inline-block;
        vertical-align: middle;
        margin-right: 8px;

        &::before {
          color: $color-error;
        }
      }
    }
  }
</style>
